{-------------------------------------------------------------------------------
                    SMACKER 3.1g 32bit Windows - Delphi API

                               -By NiteZhifter

                    http://home1.stofanet.dk/nitezhifter

                 Data & functions has been hustled an hacked
                 from system DLL's. Very beta-alike.

                 Alot of constants is unknown. 

DON'T RELEASE *ANYTHING* USING THIS FILE BEFORE YOU'VE READ AND UNDERSTOOD
THE LEGAL INFO AT www.smacker.com !

21-06-2000:
  First release. So much I don't know.
  Got the sound working at last. 

24-10-2001:
  ..still missing all those blitting functions.
  Correcting most constants.
  Made some adjustments to function parameters and return values.
  Added:
     GetSmackerVersion()
     SmackerVolumePan()
     overloaded SmackOpen() works now with a filehandle
     SmackerCheckCursor() overloaded
     SmackerRestoreCursor()

-------------------------------------------------------------------------------}
unit smackw32;

interface
uses windows;

const
  smkdll = 'Smackw32.dll';

Type

  TrgbTriple = packed record
    Red,
    Green,
    Blue  : byte;
  end;

  HSmack = ^TSmack;
  TSmack = record
    MAGICID : array [0..3] of char;
    Width,
    Height,
    TotalFrames  : Longword;

    data1   : array [0..87] of byte;
    HasbeenPlayed : LongBool; // i don't know. perhaps some palette realization
                              // flag ?
    Palette : array [0..255] of TrgbTriple;
    data2   : array [1..5] of byte;
    CurrentFrame:LongWord;
    data3   : array [0..200] of byte;
    // somewhere these exists:
    // LastRectx,
    //LastRecty,
    //LastRectw,
    //LastRecth,
    //LargestInTrack
  end;

  u16 = Word;
  Pword = ^word;

  HSmackBlit = pointer;

  TSMACKCURSOR = type longword; // force strong typecheck

{SmackSetSystemRes}
const
  SMACKRES_DEFAULT = 0;
  SMACKRES_512x384 = 1;
  SMACKRES_640x480 = 2;
  SMACKRES_800x600 = 3;
  SMACKRES_1024x768= 4;


{ SmackOpen() }

const
  SMACKOPEN_FRAMERATE  = $80;
  SMACKOPE_NOSKIP      = $400;
  SMACKOPEN_SIMULATE   = $800;
  SMACKOPEN_FILEHANDLE = $1000;
  SMACKOPEN_TRACKS     = $2000;
  SMACKOPEN_HEIGHTx2INT= $100000;
  SMACKOPEN_HEIGHTx2DBL= $200000;
  SMACKOPEN_CRASH      = $2000000;
  SMACKOPEN_NEEDPAN         = $20;
  SMACKOPEN_NEEDVOLUME      = $40;
  SMACKOPEN_AUTOEXTRA       = $0; // smacker determines the extra buffer size

{SURFACE TYPES?}
const
  SMACKBUFFER8       =$0;        // 8bit palettized
  SMACKBUFFER555     =$80000000; // 15bit
  SMACKBUFFER565     =$C0000000; // 16bit
  SMACKBUFFERREVERSED=$1;        // "OR" this to choose bottom->top
  SMACKBUFFERUNKNOWN =$FFFFFFFF; // Unsupported surface

//Rectangles. Get access to smackerdata via SmackToBufferRect()
  // SMACKSURFACEFAST = ??
  // SMACKSURFACESLOW = ??
  // SMACKSURFACEDIRECT = ??


// Volume & Pan
const
  SMACKPANCENTER = HIGH(SmallInt);
  SMACKVOLCENTER = HIGH(SmallInt);
  // Track bits
  SMACKTRACK1 = $2000;
  SMACKTRACK2 = $4000;
  SMACKTRACK3 = $8000;
  SMACKTRACK4 = $10000;
  SMACKTRACK5 = $20000;
  SMACKTRACK6 = $40000;
  SMACKTRACK7 = $80000;
  SMACKTRACKALL=$FE000;

function SmackOpen(FileName:pchar;flags:Longword;
                   extrabuf:LongWord=SMACKOPEN_AUTOEXTRA):HSmack;overload;
stdcall  external smkdll name '_SmackOpen@12';
function SmackOpen(FileHandle:THandle;flags:Longword;
                   extrabuf:LongWord=SMACKOPEN_AUTOEXTRA):HSmack;overload;
stdcall  external smkdll name '_SmackOpen@12';

function SmackSetSystemRes(mode:LongWord):Longword;stdcall
  external smkdll name '_SmackSetSystemRes@4';

procedure SmackFrameRate(framerate:LongWord);stdcall
  external smkdll name '_SmackFrameRate@4';

procedure SmackNextFrame(smk:HSmack);stdcall
  external smkdll name '_SmackNextFrame@4';

procedure SmackDoFrame(smk:HSmack);stdcall
  external smkdll name '_SmackDoFrame@4';

{procedure SmackToScreen(smk:HSmack;left,top,Pitch:LongWord;WinTbl:pword;SetBank,Flags:LongWord);stdcall
  external smkdll name '_SmackToScreen@28';}
  { Works under DOS API only...}

procedure SmackToBuffer(smk:HSmack;left,Top,Pitch,Height:LongWord;pBuf:Pointer;Flags:LongWord);
  stdcall external smkdll name '_SmackToBuffer@28';

function SmackWait(smk:HSmack):LongBool;stdcall
  external smkdll name '_SmackWait@4';

procedure SmackSimulate(Datarate:longword);stdcall
  external smkdll name '_SmackSimulate@4';

procedure SmackClose(smk:HSmack);stdcall
  external smkdll name '_SmackClose@4';

function SmackSoundUseDirectSound(DS:Pointer):longbool;stdcall
  external smkdll name '_SmackSoundUseDirectSound@4';

function SmackSoundUseWin:longbool;stdcall
  external smkdll name '_SmackSoundUseWin@0';

procedure SmackSoundCheck;stdcall
  external smkdll name '_SmackSoundCheck@0';

function SmackSoundSetDirectSoundHWND(HWND:LongWord):longBool;stdcall
  external smkdll name'_SmackSoundSetDirectSoundHWND@4';

function SmackSoundOnOff(smk:HSmack;TurnOn:Longword):LongBool;stdcall
  external smkdll name'_SmackSoundOnOff@8';

function SmackSoundInTrack(smk:Hsmack;trackflags:LongWord):LongBool;stdcall
  external smkdll name'_SmackSoundInTrack@8';

function SmackDDSurfaceType(Primary:Pointer):LongWord;stdcall
  external smkdll name'_SmackDDSurfaceType@4';

function SmackBlitOpen(Flags:LongWord):HSmackBlit;stdcall
  external smkdll name'_SmackBlitOpen@4';

procedure SmackBlitClose(smkblt:HSmackBlit);StdCall
  external smkdll name'_SmackBlitClose@4';

procedure SmackBlit(blit:HSMACKBLIT; Dest:Pointer;destpitch,destx,desty:LongWord;
                    src:Pointer; srcpitch,srcx,srcy,srcw,srch:LongWord);
stdcall external smkdll name'_SmackBlit@44';

Function SmackCheckCursor(wnd:HWND;Rect:TRECT):TSMACKCURSOR;
overload; stdcall; external smkdll name'_SmackCheckCursor@20';

Function SmackCheckCursor(wnd:HWND;top,left,width,height:longword):TSMACKCURSOR;
overload; stdcall; external smkdll name'_SmackCheckCursor@20';

procedure SmackRestoreCursor(Cursor:TSMACKCURSOR);
stdcall external smkdll name'_SmackRestoreCursor@4';

procedure SmackVolumePan(Smack:HSmack;Tracks:Longword;Volume,Pan:longword);
  stdcall external smkdll name'_SmackVolumePan@16';

function GetSmackerVersion(vname:string='ProductVersion'):string;

implementation

function GetSmackerVersion(vname:string='ProductVersion'):string;
const
  FMTLEN = 1024;
var
  Info,
  Lang : pointer;
  infosize,LangLen,destlen:longword;
  fmt,Dest:pchar;
  hw,lw:longword;
  P:pointer;
begin

  infosize := GetFileVersionInfoSize(smkdll,hw);
  if infosize=0 then exit;
  GetMem(Info,infosize);
  if GetFileVersionInfo(smkdll,0,infosize,info) then
  begin
    lang:=nil;
    VerQueryValue(Info,'/VarFileInfo/Translation',Lang,LangLen);
    if langlen<>0 then
      begin
        hw := Plongword(Lang)^ and $0000FFFF;
        lw := Plongword(Lang)^ and $FFFF0000;
      end
    else
      begin
        lw :=$0409;
        hw :=$04E4;
      end;

    p :=  pchar(vname);
    GetMem(fmt,FMTLEN);
    asm
      push [p]; push [hw]; push [lw]; // marshall 3 parameters
    end;
    wsprintf(fmt,'\StringFileInfo\%4.4x%4.4x\%s');
    asm
      add esp, 20; // ditch 2+3 parameters (wsprintf uses cdecl)
    end;

    if VerQueryValue(Info,fmt,pointer(dest),destlen) then  result := dest;

    FreeMem(fmt,FMTLEN);
  end;

  if infosize >0 then FreeMem(info,infosize);
end;
end.
